(* app: 'c. 'b. 'a.
	['c list] / 'a -> 'c list / (['c list] / 'b -> 'a / 'b) *)
let rec app lst = match lst with
    [] -> shift (fun k -> k)
  | a :: rest -> a :: app rest
in

(* f : 'c. 'b. 'a. 
       ['c] / 'a -> ([int list] / 'b -> int list / 'b) / 'a *)
let rec f unit = reset (fun () -> app [1; 2; 3; 4; 5])
in

let rec append lst1 lst2 = (reset (fun () -> app lst1)) lst2
in 

(* (append [1; 2] [3; 4], append [true; false] [false; true]) *)

(* = ([1; 2; 3; 4], [true; false; false; true]) *)

let ans = (f ()) [6; 7; 8; 9; 10] in
let ans = append [1; 2;3] [4; 5; 6] 

(* = [1; 2; 3; 4; 5; 6; 7; 8; 9; 10] *)

in

let rec print_lst lst = match lst with
    [] -> ()
  | a :: rest -> print_int a; print_byte 59; print_byte 32; print_lst rest 
in

print_byte 91; 
print_lst ans;
print_byte 93;
print_newline ()
