(* percent: 'e. 'd. 'c. 'b. 'a. 
	([(['e] / 'b -> 'd / 'c)] / 'a -> 'd / (['e] / 'b -> 'a / 'c)) *)
let rec percent to_int =
  shift (fun k -> let rec f x = k (to_int x) in f)
in

(* int: 'b. 'a. (['b] / 'a -> 'b / 'a) *)
let rec int s = s
in

(* bool: 'a. ([bool] / 'a -> int / 'a) *)
let rec bool b = if b then 100 else -100
in

(* printf: 'c. 'b. 'a. 
	([([unit] / 'b -> 'b / 'c)] / 'a -> 'c / 'a) *)
let rec printf pattern = reset (fun () -> pattern ())
in

(* example of % % *)

let rec pattern1 unit = 1 :: percent percent :: 1 :: percent percent :: 1 :: []
in

let rec f x = printf pattern1
in

(* reset ǤʤƤϤʤäݤ *)

let ans = (reset (fun () -> ((reset (fun () -> (f ()) int)) 3) bool)) true

(* = [1; 3; 1; 100; 1] *)

in

let rec print_lst lst = match lst with
    [] -> ()
  | a :: rest -> print_int a; print_byte 59; print_byte 32; print_lst rest 
in

print_byte 91;
print_lst ans;
print_byte 93;
print_newline ()
