let rec visit lst = match lst with
  | [] -> []
  | a :: rest -> visit (shift (fun k -> a :: (k rest))) in

let rec traverse lst = reset (fun () -> visit lst) in 

let ans = traverse [1; 2; 3; 4; 5] in
(* = [1; 2; 3; 4; 5] *)
(* control/prompt -> [5; 4; 3; 2; 1] *)

(* print out int list *)
let rec print_lst lst = match lst with
  | [] -> ()
  | a :: rest -> print_int a; print_byte 59; print_byte 32; print_lst rest

in 
print_byte 91;
print_lst ans;
print_byte 93;
print_newline () 


